package com.fp.persistence.pgeneral.batch;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBATCHPROCESS*/
@Entity(name="TgeneBatchProcess")
@Table(name="TGENEBATCHPROCESS")
public class TgeneBatchProcess extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBatchProcess
*/
@EmbeddedId
private TgeneBatchProcessKey pk;
@Column(name="CATALOGTYPEPROCESS", nullable=false)

/**
* Codigo de catalogo  GEN proceso general consulta, mantenimiento, TRA a nivel de transaccion finacniera, ITEM a niveld e rubro de una trnsaccion financiera, BATH comandos de fin de dia
*/
private String catalogtypeprocess;

@Column(name="CATALOGCODETYPEPROCESS", nullable=false)

/**
* Codigo de tabla de catalogo del proceso de negocio de la aplicacion
*/
private String catalogcodetypeprocess;

@Column(name="PROCESSORDER", nullable=true)

/**
* Orden de proceso de la regla. 
*/
private Integer processorder;

@Column(name="ACTIONCODE", nullable=false)

/**
* Codigo de accion a ajecutar, ejm,  CAPITALIZE, CUT
*/
private String actioncode;

@Column(name="ACTIVE", nullable=true)

/**
* Y se ejecuta la regla al ejecutar el fin de dia,  N no se ejecuta la regla al ejecutar el fin de dia.
*/
private String active;

/**Contructor por defecto*/
public TgeneBatchProcess(){
}
/**Contructor de TgeneBatchProcess
@param pPk Clave Primaria del entity
@param pCatalogtypeprocess Codigo de catalogo  GEN proceso general consulta, mantenimiento, TRA a nivel de transaccion finacniera, ITEM a niveld e rubro de una trnsaccion financiera, BATH comandos de fin de dia
@param pCatalogcodetypeprocess Codigo de tabla de catalogo del proceso de negocio de la aplicacion
@param pActioncode Codigo de accion a ajecutar, ejm,  CAPITALIZE, CUT
*/
public TgeneBatchProcess(TgeneBatchProcessKey pPk,String pCatalogtypeprocess,String pCatalogcodetypeprocess,String pActioncode){
 this();
 pk=pPk;
 catalogtypeprocess=pCatalogtypeprocess;
 catalogcodetypeprocess=pCatalogcodetypeprocess;
 actioncode=pActioncode;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBatchProcess
*/
public static TgeneBatchProcess find(EntityManager pEntityManager,TgeneBatchProcessKey pKey) throws Exception{
    TgeneBatchProcess obj = pEntityManager.find(TgeneBatchProcess.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBatchProcess
@return El objeto que referencia a la Clave primaria de TgeneBatchProcess
*/
public TgeneBatchProcessKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBatchProcess
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBatchProcess
*/
public void setPk(TgeneBatchProcessKey pPk){
  pk=pPk;
}
/**Obtiene el valor de catalogtypeprocess
@return valor de catalogtypeprocess*/
public String getCatalogtypeprocess(){
  return catalogtypeprocess;
}
/**Fija el valor de catalogtypeprocess
@param pCatalogtypeprocess nuevo Valor de catalogtypeprocess*/
public void setCatalogtypeprocess(String pCatalogtypeprocess){
  catalogtypeprocess=pCatalogtypeprocess;
}

/**Obtiene el valor de catalogcodetypeprocess
@return valor de catalogcodetypeprocess*/
public String getCatalogcodetypeprocess(){
  return catalogcodetypeprocess;
}
/**Fija el valor de catalogcodetypeprocess
@param pCatalogcodetypeprocess nuevo Valor de catalogcodetypeprocess*/
public void setCatalogcodetypeprocess(String pCatalogcodetypeprocess){
  catalogcodetypeprocess=pCatalogcodetypeprocess;
}

/**Obtiene el valor de processorder
@return valor de processorder*/
public Integer getProcessorder(){
  return processorder;
}
/**Fija el valor de processorder
@param pProcessorder nuevo Valor de processorder*/
public void setProcessorder(Integer pProcessorder){
  processorder=pProcessorder;
}

/**Obtiene el valor de actioncode
@return valor de actioncode*/
public String getActioncode(){
  return actioncode;
}
/**Fija el valor de actioncode
@param pActioncode nuevo Valor de actioncode*/
public void setActioncode(String pActioncode){
  actioncode=pActioncode;
}

/**Obtiene el valor de active
@return valor de active*/
public String getActive(){
  return active;
}
/**Fija el valor de active
@param pActive nuevo Valor de active*/
public void setActive(String pActive){
  active=pActive;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBatchProcess))return false;
    TgeneBatchProcess that = (TgeneBatchProcess) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneBatchProcess
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneBatchProcess
*/
public Object createInstance(){
 TgeneBatchProcess instance=new TgeneBatchProcess();	
 instance.setPk(new TgeneBatchProcessKey());
 return instance;
}
/**Clona la entidad TgeneBatchProcess
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBatchProcess p=(TgeneBatchProcess)this.clone();
  p.setPk((TgeneBatchProcessKey)this.pk.cloneMe());
  return p;
}
}
